﻿using MLogics.VisXpert.Online.Editor;
using System;

namespace Example_Variable_Driver.Configuration
{
    public class ModbusGroupConfig: GroupConfig
    {
        public string Address
        {
            get { return config.GetConfigValue("Modbus", "Address", "127.0.0.1"); }
            set 
            { 
                if(config.SetConfigValue("Modbus", "Address", value))
                    OnPropertyChanged(nameof(Address));
            }
        }

        public int Port
        {
            get { return config.GetConfigValueInt("Modbus", "Port", 502); }
            set 
            {
                if (config.SetConfigValue("Modbus", "Port", value.ToString()))
                    OnPropertyChanged(nameof(Port));
            }
        }

        public byte ModbusID
        {
            get { return (byte)config.GetConfigValueInt("Modbus", "ModbusID", 0); }
            set 
            { 
                if(config.SetConfigValue("Modbus", "ModbusID", value.ToString()))
                    OnPropertyChanged(nameof(ModbusID));
            }
        }

        public TimeSpan Timeout
        {
            get { return TimeSpan.FromSeconds(config.GetConfigValueInt("Modbus", "ModbusID", 10)); }
            set 
            {
                if (config.SetConfigValue("Modbus", "ModbusID", value.TotalSeconds.ToString()))
                    OnPropertyChanged(nameof(Timeout));
            }
        }

        public TimeSpan RetryTime
        {
            get { return TimeSpan.FromSeconds(config.GetConfigValueInt("Modbus", "ModbusID", 30)); }
            set 
            {
                if (config.SetConfigValue("Modbus", "ModbusID", value.TotalSeconds.ToString()))
                    OnPropertyChanged(nameof(RetryTime));
            }
        }
    }
}
