﻿using MLogics.VisXpert.Online.Editor;

namespace Example_Variable_Driver.Configuration
{
    public class ModbusVarConfig: VariableConfig
    {
        public ModbusDataAreas ModbusDataArea
        {
            get
            {
                string tmp = config.GetConfigValue("Modbus", "ModbusDataArea", ModbusDataAreas.HoldingRegisters.ToString());
                return (ModbusDataAreas)System.Enum.Parse(typeof(ModbusDataAreas), tmp);
            }
            set 
            { 
                if(config.SetConfigValue("Modbus", "ModbusDataArea", value.ToString()))
                    OnPropertyChanged(nameof(ModbusDataArea));
            }
        }

        public ModbusDataTypes ModbusDataType
        {
            get
            {
                string tmp = config.GetConfigValue("Modbus", "ModbusDataType", ModbusDataTypes.int16.ToString());
                return (ModbusDataTypes)System.Enum.Parse(typeof(ModbusDataTypes), tmp);
            }
            set 
            {
                if (config.SetConfigValue("Modbus", "ModbusDataType", value.ToString()))
                    OnPropertyChanged(nameof(ModbusDataType));
            }
        }

        public int RegisterStart
        {
            get { return (ushort)config.GetConfigValueInt("Modbus", "RegisterStart", 0); }
            set 
            {
                if (config.SetConfigValue("Modbus", "RegisterStart", value.ToString()))
                    OnPropertyChanged(nameof(RegisterStart));
            }
        }

        public int RegisterCount
        {
            get { return (ushort)config.GetConfigValueInt("Modbus", "RegisterCount", 1); }
            set 
            {
                if (config.SetConfigValue("Modbus", "RegisterCount", value.ToString()))
                    OnPropertyChanged(nameof(RegisterCount));
            }
        }

        public bool ReadOnly
        {
            get { return config.GetConfigValueBool("Modbus", "ReadOnly", false); }
            set 
            {
                if (config.SetConfigValue("Modbus", "ReadOnly", value.ToString()))
                    OnPropertyChanged(nameof(ReadOnly));
            }
        }

        public string ReadExpression
        {
            get { return config.GetConfigValue("Modbus", "ReadExpression", ""); }
            set 
            {
                if (config.SetConfigValue("Modbus", "ReadExpression", value))
                    OnPropertyChanged(nameof(ReadExpression));
            }
        }

        public string WriteExpression
        {
            get { return config.GetConfigValue("Modbus", "WriteExpression", ""); }
            set 
            { 
                if(config.SetConfigValue("Modbus", "WriteExpression", value))
                    OnPropertyChanged(nameof(WriteExpression));
            }
        }
    }
}
