﻿using MLogics.VisXpert.Online.Server;
using System;

namespace Example_Variable_Driver
{
    internal class ModbusServerStatisticsProvider
    {

        public static ModbusServerStatistics GetStatistics(Server Server)
        {
            var stats = new ModbusServerStatistics();
            ServerStatisticsProvider.GetStatistics(Server, stats);

            double totaltime = 0;
            foreach (var grp in Server.Groups)
            {
                if(grp is ModbusServerGrp mbgrp) totaltime += mbgrp.AverageVarResponseTime.TotalMilliseconds;
            }

            if (stats.ConnectedGroupCount > 0)
                stats.AverageVarResponseTime = TimeSpan.FromMilliseconds(totaltime/stats.ConnectedGroupCount);
            else
                stats.AverageVarResponseTime = new TimeSpan(0);
            return stats;
        }

        public class ModbusServerStatistics: ServerStatisticsProvider.ServerStatistics
        {
            public TimeSpan AverageVarResponseTime { get; set; }
        }
    }
}
