﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Globalization;
using System.IO;
using System.Linq;
using System.Net;
using System.Reflection;
using System.Runtime.CompilerServices;
using System.Security;
using System.Text;
using System.Threading.Tasks;
using Microsoft.VisualBasic;

namespace Example_Variable_Driver.NetScan
{
    public class ModbusScanner
    {
        public ModbusScanner()
        {
            Scanner = new IPScanner();
            Scanner.NewAdressFound += OnScanner_NewAdressFound;
            Scanner.ScanComplete += OnScanner_ScanComplete;
        }

        public event EventHandler<AdressFoundEventArgs> NewAdressFound;
        public event EventHandler<EventArgs> ScanComplete;

        private IPScanner Scanner;

        public IList<IPEndPoint> DiscoveredModbusDevices { get; } = new List<IPEndPoint>();

        public bool isRunning { get { return Scanner.isRunning; } }

        public void BeginScan()
        {
            List<IPEndPoint> AdressList = new List<IPEndPoint>();

            // Build Address List to Check
            foreach (IPAddress IP in MLogics.Network.NetTools.GetLocalIPAdressesV4())
            {
                string BaseIP = IP.ToString().Remove(IP.ToString().LastIndexOf("."));
                for (var i = 1; i <= 255; i++)
                    AdressList.Add(new IPEndPoint(System.Net.IPAddress.Parse(BaseIP + "." + i), 502));
            }

            // Search Addresses
            Scanner.BeginScan(AdressList);
        }

        public void EndScan()
        {
            Scanner.EndScan();
        }

        public IList<IPEndPoint> Scan()
        {
            BeginScan();
            EndScan();
            return DiscoveredModbusDevices;
        }

        private void OnScanner_NewAdressFound(object sender, IPScanner.AdressFoundEventArgs e)
        {
            try
            {
                NewAdressFound?.Invoke(this, new AdressFoundEventArgs(e.Adress));
            }
            catch
            {
            }
        }

        private void OnScanner_ScanComplete(object sender, EventArgs e)
        {
            ScanComplete?.Invoke(this, e);
        }

        public class AdressFoundEventArgs : EventArgs
        {

            public IPEndPoint ModbusDevice { get; }

            public AdressFoundEventArgs(IPEndPoint ModbusDevice)
            {
                this.ModbusDevice = ModbusDevice;
            }
        }
    }

}
