﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Net;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace Example_Variable_Driver.NetScan
{
    public partial class ModbusScannerDialog : Form
    {
        private ModbusScanner scanner = new ModbusScanner();

        public IPEndPoint SelectedModbusDevice
        {
            get
            {
                if (listView1.SelectedItems.Count == 0) return null;
                return (IPEndPoint)listView1.SelectedItems[0].Tag;
            }
        } 

        public ModbusScannerDialog()
        {
            InitializeComponent();
            scanner.ScanComplete += (a, b) => { this.BeginInvoke(new Action(() => { toolStripButtonRefresh.Enabled = true; })); };
            scanner.NewAdressFound += (a, b) => { this.BeginInvoke(new Action(() => 
            {
                var item = listView1.Items.Add(b.ModbusDevice.Address.ToString());
                item.SubItems.Add(b.ModbusDevice.Port.ToString());
                item.Tag = b.ModbusDevice;
            })); };
        }

        private void ModbusScannerDialog_Load(object sender, EventArgs e)
        {
            BeginScan();
        }

        private void BeginScan()
        {
            if (scanner.isRunning) return;

            listView1.Items.Clear();
            toolStripButtonRefresh.Enabled = false;
            scanner.BeginScan();
        }

        private void toolStripButtonRefresh_Click(object sender, EventArgs e)
        {
            BeginScan();
        }

        private void buttonOK_Click(object sender, EventArgs e)
        {
            this.DialogResult = DialogResult.OK;
            this.Close();
        }

        private void buttonCancel_Click(object sender, EventArgs e)
        {
            this.DialogResult = DialogResult.Cancel;
            this.Close();
        }

        private void listView1_SelectedIndexChanged(object sender, EventArgs e)
        {
            this.buttonOK.Enabled = listView1.SelectedItems.Count > 0;
        }
    }
}
