# Register Custom Module type to VisXpert
All modules that should be used by VisXpert must be registered to 
the VisXpert Communication Module. The Registration is done via 
the Windows Registry. You need Administration Privileges in order 
to Modify the required Registry keys. After you have registered 
your Module, you have to restart VisXpert, in order for it to detect the new Module. 
After you have registered your Module, you can add it to your project. 

# Purpose
The Project registration essentially defines the module. It defines
its Type, which executables it uses and also how it appears in 
the VisXpert menu. 

# Structure
Each registered module has an Sub-key under the "Modules" registry key. 
This Sub-key has the name of the Module type. This Sub-key holds
different values, that represent different characteristics of the 
Module in question.

The Module registration Key is:
HKEY_LOCAL_MACHINE\SOFTWARE\WOW6432Node\GEFASOFT\GraphPic\8.9\Module

it can hold the following sub keys:
"Flags"=              Flags that indicate how what function the module uses or provides
"Ablauf"=             The Relative OR absolute path to the Runtime Executable
"Editor"=             The Relative OR absolute path to the Editor Executable
"Icons"=              the Path to the Executable where it should use the Icon from
"Beschreibung_7"=     An User description for the Windows Local ID (LCI) 7
"Beschreibung_9"=     An User description for the Windows Local ID (LCI) 7
"Menu"=               If you add new modules, they appear in sub-menus

# Example
Probably the easiest way is to use the following example and start 
from there. 

Windows Registry Editor Version 5.00

[HKEY_LOCAL_MACHINE\SOFTWARE\WOW6432Node\GEFASOFT\GraphPic\8.9\Module\Events]
"Flags"=dword:00001042
"Ablauf"="EventsR.exe"
"Editor"="EventsD.exe"
"Icons"="EventsR.exe,1,0,EventsD.exe,1,0,"
"Beschreibung_7"="Create Events and Actions for Cyclic events, when applications are being started etc.

Actions can range from Variables values to Applications"
"Beschreibung_9"="Create Events and Actions for Cyclic events, when applications are being started etc.

Actions can range from Variables values to Applications"
"Menu"="Scheduling and Events"