﻿using System;
using Microsoft.Win32;

namespace BatchXpert_GP_Batch
{

    /// <summary>
    /// If the requested assembly contains exists in the "BatchXper" directory, use that one
    /// </summary>
    internal class BatchXpertDirectoryAssemblyResolver
    {
        public static System.Reflection.Assembly Resolve(object sender, ResolveEventArgs e)
        {
            var AsmName = new System.Reflection.AssemblyName(e.Name);
            return TryLoadAssemblyFromDirectory(AsmName, GetBatchXpertPath());
        }

        public static string GetBatchXpertPath()
        {
            string DefaulUpdateFileFolder = Environment.GetFolderPath(Environment.SpecialFolder.ProgramFilesX86)+@"\BatchXpert\";
            string TmpString;
            RegistryKey RegKey;
            RegKey=Registry.LocalMachine.OpenSubKey(@"SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\BatchXpert");

            if (RegKey is object)
            {
                TmpString=RegKey.GetValue("InstallLocation", DefaulUpdateFileFolder).ToString().Trim('"');

                if (TmpString.EndsWith(@"\"))
                {
                    return TmpString;
                }
                else
                {
                    return TmpString+@"\";
                }
            }
            else
            {
                RegKey=Registry.LocalMachine;
                RegKey=RegKey.OpenSubKey(@"Software\Wow6432Node\Microsoft\Windows\CurrentVersion\Uninstall\BatchXpert\");

                if (RegKey is object)
                {
                    TmpString=RegKey.GetValue("InstallLocation", DefaulUpdateFileFolder).ToString().Trim('"');

                    if (TmpString.EndsWith(@"\"))
                    {
                        return TmpString;
                    }
                    else
                    {
                        return TmpString+@"\";
                    }
                }
                else
                {
                    return DefaulUpdateFileFolder;
                }
            }
        }

        private static System.Reflection.Assembly TryLoadAssemblyFromDirectory(System.Reflection.AssemblyName AsmName, string BaseDirectory)
        {
            System.IO.FileInfo fName;

            if (AsmName.Name.ToLower().EndsWith(".resources"))
            {
                fName=new System.IO.FileInfo(System.IO.Path.Combine(BaseDirectory, AsmName.CultureInfo.Name, AsmName.Name+".dll"));
                if (fName.Exists)
                    return System.Reflection.Assembly.LoadFrom(fName.FullName);

                fName=new System.IO.FileInfo(System.IO.Path.Combine(BaseDirectory, AsmName.CultureInfo.Parent.Name, AsmName.Name+".dll"));
                if (fName.Exists)
                    return System.Reflection.Assembly.LoadFrom(fName.FullName);
            }

            fName=new System.IO.FileInfo(BaseDirectory+AsmName.Name+".dll");
            if (fName.Exists)
                return System.Reflection.Assembly.LoadFrom(fName.FullName);
            return null;
        }
    }
}